#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QGraphicsScene>
#include <QAbstractGraphicsShapeItem>

namespace Ui {
class MainWindow;
}

typedef QAbstractGraphicsShapeItem ShapeItem;

class ParamList : public QMap <QString, QString>
{
   public:
      int number (QString key, int default_value = 0);
};

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();

    void readFile(QString fileName);

    ShapeItem * createRectangle (QGraphicsItem * target,
                               ParamList param);

    ShapeItem * createEllipse (QGraphicsItem * target,
                               ParamList param);

    void modifyShape (QGraphicsItem * target,
                      ShapeItem * shape,
                      ParamList param);

private:
    Ui::MainWindow * ui;
    QGraphicsScene * scene;
};

#endif // MAINWINDOW_H
